<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__nw__helper_8h" kind="file" language="C++">
    <compoundname>cy_nw_helper.h</compoundname>
    <includes local="no">stdint.h</includes>
    <includes local="no">stdbool.h</includes>
    <incdepgraph>
      <node id="14">
        <label>stdbool.h</label>
      </node>
      <node id="13">
        <label>stdint.h</label>
      </node>
      <node id="12">
        <label>cy_nw_helper.h</label>
        <link refid="cy__nw__helper_8h" />
        <childnode refid="13" relation="include">
        </childnode>
        <childnode refid="14" relation="include">
        </childnode>
      </node>
    </incdepgraph>
    <innerclass prot="public" refid="structcy__nw__ip__status__change__callback__t">cy_nw_ip_status_change_callback_t</innerclass>
    <innerclass prot="public" refid="structcy__nw__ip__address__t">cy_nw_ip_address_t</innerclass>
    <innerclass prot="public" refid="structcy__nw__ip__mac__t">cy_nw_ip_mac_t</innerclass>
    <innerclass prot="public" refid="structcy__nw__arp__cache__entry__t">cy_nw_arp_cache_entry_t</innerclass>
    <innerclass prot="public" refid="structcy__network__interface__t">cy_network_interface_t</innerclass>
      <sectiondef kind="define">
      <memberdef id="cy__nw__helper_8h_1ab64a52a0d197d094235b91fce9541453" kind="define" prot="public" static="no">
        <name>cy_assert</name>
        <param><defname>error_string</defname></param>
        <param><defname>assertion</defname></param>
        <initializer>do { (void)(assertion); } while(0)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" bodystart="20" column="9" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="20" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="enum">
      <memberdef id="group__group__nwhelper__enums_1ga124df4c582e8f964c636d7b5404ef77e" kind="enum" prot="public" static="no">
        <name>cy_nw_ip_version_t</name>
        <enumvalue id="group__group__nwhelper__enums_1gga124df4c582e8f964c636d7b5404ef77eae9a106110bd2c067d524c8384ef0bc24" prot="public">
          <name>NW_IP_IPV4</name>
          <initializer>= 4</initializer>
          <briefdescription>
<para>IPv4 version. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__nwhelper__enums_1gga124df4c582e8f964c636d7b5404ef77eabdb79c8327ef582fc83e1b8f0d240a49" prot="public">
          <name>NW_IP_IPV6</name>
          <initializer>= 6</initializer>
          <briefdescription>
<para>IPv6 version. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__nwhelper__enums_1gga124df4c582e8f964c636d7b5404ef77eaf5072b1625362a4fc21afd0d51e453f8" prot="public">
          <name>NW_IP_INVALID_IP</name>
          <initializer>= (-1)</initializer>
          <briefdescription>
<para>Invalid IP version. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cy_nw_ip_version_t: </bold><linebreak />IP version.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="37" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" bodystart="32" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="33" />
      </memberdef>
      <memberdef id="group__group__nwhelper__enums_1gac624398dadff281329ab6586120e5858" kind="enum" prot="public" static="no">
        <name>cy_network_interface_type_t</name>
        <enumvalue id="group__group__nwhelper__enums_1ggac624398dadff281329ab6586120e5858aab2624348d5a5ce28f319618c5a5c1b2" prot="public">
          <name>CY_NW_INF_TYPE_WIFI</name>
          <initializer>= 0</initializer>
          <briefdescription>
<para>Wi-Fi network interface. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__nwhelper__enums_1ggac624398dadff281329ab6586120e5858ab08a6b52a36c7308e8ba32d7744ff920" prot="public">
          <name>CY_NW_INF_TYPE_ETH</name>
          <briefdescription>
<para>Ethernet network interface. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cy_network_interface_type_t: </bold><linebreak />Network interface type.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="44" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" bodystart="40" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="41" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="typedef">
      <memberdef id="cy__nw__helper_8h_1a8afb6430a180da5ef8aa30ee772579bf" kind="typedef" prot="public" static="no">
        <type>uintptr_t</type>
        <definition>typedef uintptr_t cy_nw_ip_interface_t</definition>
        <argsstring />
        <name>cy_nw_ip_interface_t</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" bodystart="22" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="22" />
      </memberdef>
      <memberdef id="group__group__nwhelper__structures_1ga08bb004725176839034bec5172b3efb2" kind="typedef" prot="public" static="no">
        <type>void()</type>
        <definition>typedef void() cy_nw_ip_status_change_callback_func_t(cy_nw_ip_interface_t iface, void *arg)</definition>
        <argsstring>(cy_nw_ip_interface_t iface, void *arg)</argsstring>
        <name>cy_nw_ip_status_change_callback_func_t</name>
        <briefdescription>
<para>Network IP status change callback function. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">iface</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the network interface for which the callback is invoked. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">arg</parametername>
</parameternamelist>
<parameterdescription>
<para>: User data object provided during the status change callback registration.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>none </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" bodystart="58" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="58" />
      </memberdef>
      <memberdef id="group__group__nwhelper__structures_1ga161d42e2c1e8c284a5f1275e2411b22a" kind="typedef" prot="public" static="no">
        <type>void *</type>
        <definition>typedef void* cy_network_interface_object_t</definition>
        <argsstring />
        <name>cy_network_interface_object_t</name>
        <briefdescription>
<para>Network interface object. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" bodystart="83" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="83" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__nwhelper__func_1gad2beee045469986e9af0f3e98cc2593a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cy_nw_ip_initialize_status_change_callback</definition>
        <argsstring>(cy_nw_ip_status_change_callback_t *info, cy_nw_ip_status_change_callback_func_t *cbf, void *arg)</argsstring>
        <name>cy_nw_ip_initialize_status_change_callback</name>
        <param>
          <type><ref kindref="compound" refid="structcy__nw__ip__status__change__callback__t">cy_nw_ip_status_change_callback_t</ref> *</type>
          <declname>info</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__nwhelper__structures_1ga08bb004725176839034bec5172b3efb2">cy_nw_ip_status_change_callback_func_t</ref> *</type>
          <declname>cbf</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>arg</declname>
        </param>
        <briefdescription>
<para>Initialize status change callback. </para>        </briefdescription>
        <detaileddescription>
<para>Initialize <ref kindref="compound" refid="structcy__nw__ip__status__change__callback__t">cy_nw_ip_status_change_callback_t</ref> instead of directly manipulating the callback struct.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">info</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to network IP status change callback information structure which would be filled upon return </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">cbf</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to callback function to be invoked during network status change </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">arg</parametername>
</parameternamelist>
<parameterdescription>
<para>: User data object to be sent sent in the callback function</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>none </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="131" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__nwhelper__func_1gab6bb3743e63a62a560f600a49d17f4e8" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cy_nw_ip_get_ipv4_address</definition>
        <argsstring>(cy_nw_ip_interface_t iface, cy_nw_ip_address_t *addr)</argsstring>
        <name>cy_nw_ip_get_ipv4_address</name>
        <param>
          <type>cy_nw_ip_interface_t</type>
          <declname>iface</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__nw__ip__address__t">cy_nw_ip_address_t</ref> *</type>
          <declname>addr</declname>
        </param>
        <briefdescription>
<para>Retrieves the IPv4 address for an interface. </para>        </briefdescription>
        <detaileddescription>
<para>Retrieves the IPv4 address for an interface (AP or STA) if it exists.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">iface</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to network interface object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">addr</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the IP information sturcture in which the results to be stored</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>true : if IP address is present </para></simplesect>
<simplesect kind="return"><para>false : otherwise </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="144" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__nwhelper__func_1gac064ce1afc6b5f07402fdd0bbfb03073" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int</type>
        <definition>int cy_nw_str_to_ipv4</definition>
        <argsstring>(const char *ip_str, cy_nw_ip_address_t *address)</argsstring>
        <name>cy_nw_str_to_ipv4</name>
        <param>
          <type>const char *</type>
          <declname>ip_str</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__nw__ip__address__t">cy_nw_ip_address_t</ref> *</type>
          <declname>address</declname>
        </param>
        <briefdescription>
<para>Convert IPv4 string to an IP address structure. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">ip_str</parametername>
</parameternamelist>
<parameterdescription>
<para>: IPv4 address string. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">address</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the IP info structure in which the IPv4 address to be stored</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>0 : if successful </para></simplesect>
<simplesect kind="return"><para>-1 : if failed </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="154" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__nwhelper__func_1ga8f71bcd9fe077fb6eaad2e6c2794bd7e" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cy_nw_ip_register_status_change_callback</definition>
        <argsstring>(cy_nw_ip_interface_t iface, cy_nw_ip_status_change_callback_t *info)</argsstring>
        <name>cy_nw_ip_register_status_change_callback</name>
        <param>
          <type>cy_nw_ip_interface_t</type>
          <declname>iface</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__nw__ip__status__change__callback__t">cy_nw_ip_status_change_callback_t</ref> *</type>
          <declname>info</declname>
        </param>
        <briefdescription>
<para>Registers for callback function to be invoked during IP status change. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">iface</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to network interface object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">info</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the status change information structure</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>none </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="163" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__nwhelper__func_1ga7219dc7312b40ea0d047f4a44dad32a4" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cy_nw_ip_unregister_status_change_callback</definition>
        <argsstring>(cy_nw_ip_interface_t iface, cy_nw_ip_status_change_callback_t *info)</argsstring>
        <name>cy_nw_ip_unregister_status_change_callback</name>
        <param>
          <type>cy_nw_ip_interface_t</type>
          <declname>iface</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__nw__ip__status__change__callback__t">cy_nw_ip_status_change_callback_t</ref> *</type>
          <declname>info</declname>
        </param>
        <briefdescription>
<para>Un-registers IP status change callback. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">iface</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to network interface object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">info</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the status change information structure</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>none </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="172" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__nwhelper__func_1ga6e28295152dd34e6d4474d51b73f2ef6" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int</type>
        <definition>int cy_nw_host_arp_cache_clear</definition>
        <argsstring>(cy_nw_ip_interface_t iface)</argsstring>
        <name>cy_nw_host_arp_cache_clear</name>
        <param>
          <type>cy_nw_ip_interface_t</type>
          <declname>iface</declname>
        </param>
        <briefdescription>
<para>Clears the ARP cache for the interface NOTE: in LwIP, we need the netif (NetworkInterface) to do things, we can find using wifi interface. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">iface</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to network interface object</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>0 : success 1 : fail </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="182" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__nwhelper__func_1ga0366c24466017d402f414fda93c992b4" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int</type>
        <definition>int cy_nw_host_arp_cache_get_list</definition>
        <argsstring>(cy_nw_ip_interface_t iface, cy_nw_arp_cache_entry_t *list, uint32_t count, uint32_t *filled)</argsstring>
        <name>cy_nw_host_arp_cache_get_list</name>
        <param>
          <type>cy_nw_ip_interface_t</type>
          <declname>iface</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__nw__arp__cache__entry__t">cy_nw_arp_cache_entry_t</ref> *</type>
          <declname>list</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>count</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>filled</declname>
        </param>
        <briefdescription>
<para>Gets the ARP cache list for the interface. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">iface</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to network interface object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="inout">list</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to <ref kindref="compound" refid="structcy__nw__arp__cache__entry__t">cy_nw_arp_cache_entry_t</ref> array </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">count</parametername>
</parameternamelist>
<parameterdescription>
<para>: Number of entries in the array passed in list </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="inout">filled</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to get the number of entries filled in the array pointed by 'list'</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>0 : success 1 : fail </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="194" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__nwhelper__func_1ga85585d772b32c42db4c6c9ae82f1c5db" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int</type>
        <definition>int cy_nw_host_send_arp_request</definition>
        <argsstring>(cy_nw_ip_interface_t iface, const char *ip_string)</argsstring>
        <name>cy_nw_host_send_arp_request</name>
        <param>
          <type>cy_nw_ip_interface_t</type>
          <declname>iface</declname>
        </param>
        <param>
          <type>const char *</type>
          <declname>ip_string</declname>
        </param>
        <briefdescription>
<para>Send ARP request NOTE: in LwIP, we need the netif (NetworkInterface) to do things, we can find using wifi interface. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">iface</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to network interface object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">ip_string</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the IPv4 address string (Ex: "192.168.1.1") to which the ARP request to be sent</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>0 : success 1 : failed to send ARP request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="205" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__nwhelper__func_1ga8cec7b3315382e02208ba77a14733d8c" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t cy_nw_get_time</definition>
        <argsstring>(void)</argsstring>
        <name>cy_nw_get_time</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>GET time in milliseconds. </para>        </briefdescription>
        <detaileddescription>
<para><simplesect kind="return"><para>time in milliseconds </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" line="211" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>This is a collection of network helper functions which would be used by various Cypress Middleware libraries. </para>    </briefdescription>
    <detaileddescription>
    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/*</highlight></codeline>
<codeline lineno="2"><highlight class="comment"><sp />*<sp />$<sp />Copyright<sp />2019-YEAR<sp />Cypress<sp />Semiconductor<sp />Apache2<sp />$</highlight></codeline>
<codeline lineno="3"><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="4"><highlight class="normal" /></codeline>
<codeline lineno="10"><highlight class="preprocessor">#pragma<sp />once</highlight><highlight class="normal" /></codeline>
<codeline lineno="11"><highlight class="normal" /></codeline>
<codeline lineno="12"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;stdint.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="13"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;stdbool.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="14"><highlight class="normal" /></codeline>
<codeline lineno="15"><highlight class="normal" /></codeline>
<codeline lineno="16"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="17"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="18"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="19"><highlight class="normal" /></codeline>
<codeline lineno="20"><highlight class="normal" /><highlight class="preprocessor">#define<sp />cy_assert(<sp />error_string,<sp />assertion<sp />)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />do<sp />{<sp />(void)(assertion);<sp />}<sp />while(0)</highlight><highlight class="normal" /></codeline>
<codeline lineno="21"><highlight class="normal" /></codeline>
<codeline lineno="22"><highlight class="normal" /><highlight class="keyword">typedef</highlight><highlight class="normal"><sp />uintptr_t<sp />cy_nw_ip_interface_t;</highlight></codeline>
<codeline lineno="23"><highlight class="normal" /></codeline>
<codeline lineno="24"><highlight class="normal" /></codeline>
<codeline lineno="25"><highlight class="normal" /><highlight class="comment">/******************************************************</highlight></codeline>
<codeline lineno="26"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Enumerations</highlight></codeline>
<codeline lineno="27"><highlight class="comment"><sp />******************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="28"><highlight class="normal" /><highlight class="comment">/******************************************************************************/</highlight></codeline>
<codeline lineno="30"><highlight class="comment">/******************************************************************************/</highlight></codeline>
<codeline lineno="32"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">enum</highlight><highlight class="normal"><sp />nw_ip_version</highlight></codeline>
<codeline lineno="33"><highlight class="normal">{</highlight></codeline>
<codeline lineno="34"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__nwhelper__enums_1gga124df4c582e8f964c636d7b5404ef77eae9a106110bd2c067d524c8384ef0bc24">NW_IP_IPV4</ref><sp />=<sp />4,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="35"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__nwhelper__enums_1gga124df4c582e8f964c636d7b5404ef77eabdb79c8327ef582fc83e1b8f0d240a49">NW_IP_IPV6</ref><sp />=<sp />6,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="36"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__nwhelper__enums_1gga124df4c582e8f964c636d7b5404ef77eaf5072b1625362a4fc21afd0d51e453f8">NW_IP_INVALID_IP</ref><sp />=<sp />(-1),<sp /></highlight></codeline>
<codeline lineno="37"><highlight class="normal">}<sp /><ref kindref="member" refid="group__group__nwhelper__enums_1ga124df4c582e8f964c636d7b5404ef77e">cy_nw_ip_version_t</ref>;</highlight></codeline>
<codeline lineno="38"><highlight class="normal" /></codeline>
<codeline lineno="40"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">enum</highlight><highlight class="normal" /></codeline>
<codeline lineno="41"><highlight class="normal">{</highlight></codeline>
<codeline lineno="42"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__nwhelper__enums_1ggac624398dadff281329ab6586120e5858aab2624348d5a5ce28f319618c5a5c1b2">CY_NW_INF_TYPE_WIFI</ref><sp />=<sp />0,<sp /></highlight></codeline>
<codeline lineno="43"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__nwhelper__enums_1ggac624398dadff281329ab6586120e5858ab08a6b52a36c7308e8ba32d7744ff920">CY_NW_INF_TYPE_ETH</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="44"><highlight class="normal">}<sp /><ref kindref="member" refid="group__group__nwhelper__enums_1gac624398dadff281329ab6586120e5858">cy_network_interface_type_t</ref>;</highlight></codeline>
<codeline lineno="45"><highlight class="normal" /></codeline>
<codeline lineno="48"><highlight class="comment">/******************************************************************************/</highlight></codeline>
<codeline lineno="50"><highlight class="comment">/******************************************************************************/</highlight></codeline>
<codeline lineno="58"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp />void<sp />(<ref kindref="member" refid="group__group__nwhelper__structures_1ga08bb004725176839034bec5172b3efb2">cy_nw_ip_status_change_callback_func_t</ref>)(cy_nw_ip_interface_t<sp />iface,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*arg);</highlight></codeline>
<codeline lineno="59"><highlight class="normal" /></codeline>
<codeline lineno="61" refid="structcy__nw__ip__status__change__callback__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">cy_nw_ip_status_change_callback</highlight></codeline>
<codeline lineno="62"><highlight class="normal">{</highlight></codeline>
<codeline lineno="63"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__nwhelper__structures_1ga08bb004725176839034bec5172b3efb2">cy_nw_ip_status_change_callback_func_t</ref><sp />*cb_func;<sp /></highlight></codeline>
<codeline lineno="64"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*arg;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="65"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*priv;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="66"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcy__nw__ip__status__change__callback__t">cy_nw_ip_status_change_callback_t</ref>;</highlight></codeline>
<codeline lineno="67"><highlight class="normal" /></codeline>
<codeline lineno="71" refid="structcy__nw__ip__address__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">cy_nw_ip_address</highlight></codeline>
<codeline lineno="72"><highlight class="normal">{</highlight></codeline>
<codeline lineno="73"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__nwhelper__enums_1ga124df4c582e8f964c636d7b5404ef77e">cy_nw_ip_version_t</ref><sp />version;<sp /></highlight></codeline>
<codeline lineno="75"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">union</highlight><highlight class="normal" /></codeline>
<codeline lineno="76"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="77"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />v4;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="78"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />v6[4];<sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="79"><highlight class="normal"><sp /><sp /><sp /><sp />}<sp />ip;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="80"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcy__nw__ip__address__t">cy_nw_ip_address_t</ref>;</highlight></codeline>
<codeline lineno="81"><highlight class="normal" /></codeline>
<codeline lineno="83"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*<sp /><ref kindref="member" refid="group__group__nwhelper__structures_1ga161d42e2c1e8c284a5f1275e2411b22a">cy_network_interface_object_t</ref>;</highlight></codeline>
<codeline lineno="84"><highlight class="normal" /></codeline>
<codeline lineno="86" refid="structcy__nw__ip__mac__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">cy_nw_ip_mac</highlight></codeline>
<codeline lineno="87"><highlight class="normal">{</highlight></codeline>
<codeline lineno="88"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp /><sp /><sp /><sp />mac[6];<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="89"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcy__nw__ip__mac__t">cy_nw_ip_mac_t</ref>;</highlight></codeline>
<codeline lineno="90"><highlight class="normal" /></codeline>
<codeline lineno="92" refid="structcy__nw__arp__cache__entry__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">cy_nw_arp_cache_entry</highlight></codeline>
<codeline lineno="93"><highlight class="normal">{</highlight></codeline>
<codeline lineno="94"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__nw__ip__address__t">cy_nw_ip_address_t</ref><sp /><sp /><sp /><sp />ip;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="95"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__nw__ip__mac__t">cy_nw_ip_mac_t</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />mac;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="96"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcy__nw__arp__cache__entry__t">cy_nw_arp_cache_entry_t</ref>;</highlight></codeline>
<codeline lineno="97"><highlight class="normal" /></codeline>
<codeline lineno="101" refid="structcy__network__interface__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal" /></codeline>
<codeline lineno="102"><highlight class="normal">{</highlight></codeline>
<codeline lineno="103"><highlight class="normal"><sp /><sp /><sp /><sp />cy_network_interface_type_t<sp /><sp /><sp /><sp /><sp />type;<sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="104"><highlight class="normal"><sp /><sp /><sp /><sp />cy_network_interface_object_t<sp /><sp /><sp />object;<sp /><sp /><sp /></highlight></codeline>
<codeline lineno="105"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcy__network__interface__t">cy_network_interface_t</ref>;</highlight></codeline>
<codeline lineno="106"><highlight class="normal" /></codeline>
<codeline lineno="109"><highlight class="comment">/*****************************************************************************/</highlight></codeline>
<codeline lineno="118"><highlight class="comment">/*****************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="119"><highlight class="normal" /></codeline>
<codeline lineno="131"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__nwhelper__func_1gad2beee045469986e9af0f3e98cc2593a">cy_nw_ip_initialize_status_change_callback</ref>(<ref kindref="compound" refid="structcy__nw__ip__status__change__callback__t">cy_nw_ip_status_change_callback_t</ref><sp />*info,<sp /><ref kindref="member" refid="group__group__nwhelper__structures_1ga08bb004725176839034bec5172b3efb2">cy_nw_ip_status_change_callback_func_t</ref><sp />*cbf,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*arg);</highlight></codeline>
<codeline lineno="132"><highlight class="normal" /></codeline>
<codeline lineno="144"><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__nwhelper__func_1gab6bb3743e63a62a560f600a49d17f4e8">cy_nw_ip_get_ipv4_address</ref>(cy_nw_ip_interface_t<sp />iface,<sp /><ref kindref="compound" refid="structcy__nw__ip__address__t">cy_nw_ip_address_t</ref><sp />*addr);</highlight></codeline>
<codeline lineno="145"><highlight class="normal" /></codeline>
<codeline lineno="154"><highlight class="keywordtype">int</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__nwhelper__func_1gac064ce1afc6b5f07402fdd0bbfb03073">cy_nw_str_to_ipv4</ref>(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*ip_str,<sp /><ref kindref="compound" refid="structcy__nw__ip__address__t">cy_nw_ip_address_t</ref><sp />*address);</highlight></codeline>
<codeline lineno="155"><highlight class="normal" /></codeline>
<codeline lineno="163"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__nwhelper__func_1ga8f71bcd9fe077fb6eaad2e6c2794bd7e">cy_nw_ip_register_status_change_callback</ref>(cy_nw_ip_interface_t<sp />iface,<sp /><ref kindref="compound" refid="structcy__nw__ip__status__change__callback__t">cy_nw_ip_status_change_callback_t</ref><sp />*info);</highlight></codeline>
<codeline lineno="164"><highlight class="normal" /></codeline>
<codeline lineno="172"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__nwhelper__func_1ga7219dc7312b40ea0d047f4a44dad32a4">cy_nw_ip_unregister_status_change_callback</ref>(cy_nw_ip_interface_t<sp />iface,<sp /><ref kindref="compound" refid="structcy__nw__ip__status__change__callback__t">cy_nw_ip_status_change_callback_t</ref><sp />*info);</highlight></codeline>
<codeline lineno="173"><highlight class="normal" /></codeline>
<codeline lineno="182"><highlight class="keywordtype">int</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__nwhelper__func_1ga6e28295152dd34e6d4474d51b73f2ef6">cy_nw_host_arp_cache_clear</ref>(<sp />cy_nw_ip_interface_t<sp />iface<sp />);</highlight></codeline>
<codeline lineno="183"><highlight class="normal" /></codeline>
<codeline lineno="194"><highlight class="keywordtype">int</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__nwhelper__func_1ga0366c24466017d402f414fda93c992b4">cy_nw_host_arp_cache_get_list</ref>(<sp />cy_nw_ip_interface_t<sp />iface,<sp /><ref kindref="compound" refid="structcy__nw__arp__cache__entry__t">cy_nw_arp_cache_entry_t</ref><sp />*list,<sp />uint32_t<sp />count,<sp />uint32_t<sp />*filled<sp />);</highlight></codeline>
<codeline lineno="195"><highlight class="normal" /></codeline>
<codeline lineno="205"><highlight class="keywordtype">int</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__nwhelper__func_1ga85585d772b32c42db4c6c9ae82f1c5db">cy_nw_host_send_arp_request</ref>(<sp />cy_nw_ip_interface_t<sp />iface,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*ip_string<sp />);</highlight></codeline>
<codeline lineno="206"><highlight class="normal" /></codeline>
<codeline lineno="211"><highlight class="normal">uint32_t<sp /><ref kindref="member" refid="group__group__nwhelper__func_1ga8cec7b3315382e02208ba77a14733d8c">cy_nw_get_time</ref><sp />(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="212"><highlight class="normal" /></codeline>
<codeline lineno="215"><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="216"><highlight class="normal">}</highlight></codeline>
<codeline lineno="217"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight></codeline>
    </programlisting>
    <location file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/network/cy_nw_helper.h" />
  </compounddef>
</doxygen>